SystemOrganization addCategory: #'TxText-Athens'!

Morph subclass: #TxLayoutViewMorph
	instanceVariableNames: 'layoutView'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TxText-Athens'!

!TxLayoutViewMorph class methodsFor: 'examples' stamp: 'IgorStasenko 8/30/2013 14:58'!
openInWindowWithString: aString

	| text |
	
	text := TxModel new.
	text atAttribute: TxFontAttribute  put: (LogicalFont familyName: 'Monaco' pointSize: 20 ).
	text endPosition insert: aString.
	
	^ self openInWindowWithText: text! !

!TxLayoutViewMorph class methodsFor: 'examples' stamp: 'FernandoOlivero 9/4/2013 11:27'!
openInWindowWithText: aTxModel

	| viewMorph  wrapper |
	
	viewMorph := self text: aTxModel.
	
	viewMorph 
		hResizing: #spaceFill;
		vResizing: #spaceFill.
		
	wrapper := AthensWrapMorph new.
	
	wrapper addMorph: viewMorph.
	
	^ wrapper openInWindow! !

!TxLayoutViewMorph class methodsFor: 'instance creation' stamp: 'FernandoOlivero 9/4/2013 11:28'!
text: aTxModel 
	| view |
	view := self new.
	view initializeText: aTxModel .
	^ view ! !

!TxLayoutViewMorph methodsFor: 'drawing' stamp: 'FernandoOlivero 9/4/2013 13:14'!
drawOn: aCanvas
	"do nothing"! !

!TxLayoutViewMorph methodsFor: 'drawing' stamp: 'FernandoOlivero 9/4/2013 13:30'!
drawOnAthensCanvas: aCanvas
	"before rendering transform from a global coordinates (Morphic) to relative coordinates (Athens)"
	aCanvas pathTransform restoreAfter: [ 
		aCanvas pathTransform 
			translateBy: self bounds origin;
			scaleBy: 1.0001.
		aCanvas 
			setPaint: Color white;
			drawShape: (0@0 extent:self extent).
		layoutView renderOn: aCanvas ].! !

!TxLayoutViewMorph methodsFor: 'updating' stamp: 'FernandoOlivero 9/4/2013 13:30'!
extentChanged
	
	self extent ~= layoutView extent ifTrue: [  layoutView extent: self extent ].
	
	! !

!TxLayoutViewMorph methodsFor: 'initialization' stamp: 'FernandoOlivero 9/4/2013 11:28'!
initializeText: aTxModel 
	layoutView := TxAthensLayoutView on: aTxModel extent: self extent .
! !

!TxLayoutViewMorph methodsFor: 'geometry' stamp: 'FernandoOlivero 9/4/2013 13:13'!
layoutPositionAt:  aTextPosition ifOutside: aBlock 
	^ layoutView layoutPositionAt:  aTextPosition ifOutside: aBlock! !

!TxLayoutViewMorph methodsFor: 'updating' stamp: 'FernandoOlivero 9/3/2013 02:12'!
ownerChanged
	self extentChanged.! !

!TxLayoutViewMorph methodsFor: 'accesing' stamp: 'FernandoOlivero 9/4/2013 12:36'!
text
	^ layoutView text ! !

!TxLayoutViewMorph methodsFor: 'geometry' stamp: 'FernandoOlivero 9/4/2013 13:37'!
textPositionAt:  aPoint  
	^ layoutView textPositionAt:  aPoint! !

!TxLayoutViewMorph methodsFor: 'updating' stamp: 'FernandoOlivero 9/4/2013 12:39'!
updateMorph
	layoutView resetLayout.
	! !

Morph subclass: #TxTextEditorMorph
	instanceVariableNames: 'controller cursorMorph layoutViewMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TxText-Athens'!

!TxTextEditorMorph class methodsFor: 'keybindings' stamp: 'FernandoOlivero 9/4/2013 11:18'!
addBackspaceTo: aBuilder 
	(aBuilder shortcut: #backspace )
		category: self class name 
		default: Character backspace
		do: [ :morph | morph backspaceAtCursor ].! !

!TxTextEditorMorph class methodsFor: 'keybindings' stamp: 'FernandoOlivero 9/4/2013 11:18'!
addEnterTo: aBuilder 
	(aBuilder shortcut: #enter )
		category: self class name 
		default: Character enter
		do: [ :morph | morph addNewLineAtCursor ].! !

!TxTextEditorMorph class methodsFor: 'keybindings' stamp: 'FernandoOlivero 9/4/2013 11:18'!
addMoveDownTo: aBuilder 
	(aBuilder shortcut: #moveDown )
		category: self class name 
		default: Character arrowDown
		do: [ :morph | morph moveCursorDown ].! !

!TxTextEditorMorph class methodsFor: 'keybindings' stamp: 'FernandoOlivero 9/4/2013 11:18'!
addMoveLeftTo: aBuilder 
	(aBuilder shortcut: #moveLeft)
		category: self class name 
		default: Character arrowLeft
		do: [ :morph | morph moveCursorLeft  ].! !

!TxTextEditorMorph class methodsFor: 'keybindings' stamp: 'FernandoOlivero 9/4/2013 11:18'!
addMoveRightTo: aBuilder 
	(aBuilder shortcut: #moveRight )
		category: self class name 
		default: Character arrowRight
		do: [ :morph | morph moveCursorRight  ].! !

!TxTextEditorMorph class methodsFor: 'keybindings' stamp: 'FernandoOlivero 9/4/2013 11:18'!
addMoveUpTo: aBuilder 
	(aBuilder shortcut: #moveUp )
		category: self class name 
		default: Character arrowUp
		do: [ :morph | morph moveCursorUp  ].! !

!TxTextEditorMorph class methodsFor: 'keybindings' stamp: 'FernandoOlivero 9/4/2013 11:18'!
buildTextEditorKeymapsOn: aBuilder

	self
		addMoveLeftTo: aBuilder  ;
		addMoveRightTo: aBuilder ;
		addMoveUpTo: aBuilder  ;
		addMoveDownTo: aBuilder  ;
		addEnterTo: aBuilder  ;
		addBackspaceTo: aBuilder  .
		! !

!TxTextEditorMorph class methodsFor: 'intialization' stamp: 'FernandoOlivero 9/4/2013 11:18'!
intialize
	super initialize.
	self  attachKeymapCategory: self class name. ! !

!TxTextEditorMorph class methodsFor: 'examples' stamp: 'FernandoOlivero 9/4/2013 11:30'!
openInWindowWithString: aString

	| text |
	
	text := TxModel new.
	text atAttribute: TxFontAttribute  put: (LogicalFont familyName: 'Monaco' pointSize: 20 ).
	text endPosition insert: aString.
	
	^ self openInWindowWithText: text! !

!TxTextEditorMorph class methodsFor: 'examples' stamp: 'FernandoOlivero 9/4/2013 11:32'!
openInWindowWithText: aTxModel 
	| editorMorph wrapper |
	editorMorph := self text: aTxModel.
	editorMorph
		hResizing: #spaceFill;
		vResizing: #spaceFill.
		
	wrapper := AthensWrapMorph new.
	wrapper addMorph: editorMorph.
	
	^ wrapper openInWindow! !

!TxTextEditorMorph class methodsFor: 'instance creation' stamp: 'FernandoOlivero 9/4/2013 11:23'!
text: aTxModel 
	| editor |
	editor := self new.
	editor initializeText: aTxModel .
	^ editor ! !

!TxTextEditorMorph methodsFor: 'editing' stamp: 'FernandoOlivero 9/4/2013 11:38'!
backspaceAtCursor
	controller focus delete.
	self controllerChanged.! !

!TxTextEditorMorph methodsFor: 'drawing' stamp: 'FernandoOlivero 9/4/2013 14:22'!
borderWidth
	^ 3 ! !

!TxTextEditorMorph methodsFor: 'updating' stamp: 'FernandoOlivero 9/4/2013 12:56'!
controllerChanged
	layoutViewMorph updateMorph.
	self cursorChanged ! !

!TxTextEditorMorph methodsFor: 'updating' stamp: 'FernandoOlivero 9/4/2013 13:03'!
cursorChanged
	self updateCursor.
	self changed.
	! !

!TxTextEditorMorph methodsFor: 'accesing' stamp: 'FernandoOlivero 9/4/2013 12:42'!
cursorTextPosition
	^ controller cursorTextPosition! !

!TxTextEditorMorph methodsFor: 'initialization' stamp: 'FernandoOlivero 9/4/2013 12:59'!
defaultCursor
	^ TxCaretCursor new! !

!TxTextEditorMorph methodsFor: 'editing' stamp: 'FernandoOlivero 9/4/2013 11:38'!
deleteAtCursor 
	controller focus delete.
	self controllerChanged.! !

!TxTextEditorMorph methodsFor: 'drawing' stamp: 'FernandoOlivero 9/4/2013 14:13'!
drawCursorOn: aCanvas
	cursorMorph drawOn: aCanvas.  
	! !

!TxTextEditorMorph methodsFor: 'drawing' stamp: 'FernandoOlivero 9/4/2013 14:23'!
drawKeyboardFocusOn: aCanvas 
	| stroke |
	stroke := aCanvas setStrokePaint: Color blue  .
	stroke width: self borderWidth.
	aCanvas
		setShape:  (0@0 extent: self innerBounds extent) ;
		draw.
		! !

!TxTextEditorMorph methodsFor: 'drawing' stamp: 'FernandoOlivero 9/4/2013 14:14'!
drawOn: aCanvas
	! !

!TxTextEditorMorph methodsFor: 'drawing' stamp: 'FernandoOlivero 9/4/2013 14:25'!
drawOnAthensCanvas: aCanvas
	| pathTransform |
	pathTransform := aCanvas pathTransform.
	pathTransform restoreAfter: [
		pathTransform translateBy: self innerBounds topLeft.  
		self updateLayoutView;updateCursor.
		layoutViewMorph drawOnAthensCanvas: aCanvas.
		self hasKeyboardFocus ifTrue: [ 
			self drawKeyboardFocusOn: aCanvas .
			self drawCursorOn: aCanvas ] ].! !

!TxTextEditorMorph methodsFor: 'drawing' stamp: 'FernandoOlivero 9/4/2013 14:14'!
drawSubmorphsOn: aCanvas
	! !

!TxTextEditorMorph methodsFor: 'event handling' stamp: 'FernandoOlivero 9/4/2013 11:10'!
handlesKeyDown: event
	^ true! !

!TxTextEditorMorph methodsFor: 'event handling' stamp: 'FernandoOlivero 9/4/2013 11:10'!
handlesKeyboard: evt
	
	^true! !

!TxTextEditorMorph methodsFor: 'event handling' stamp: 'FernandoOlivero 9/4/2013 11:10'!
handlesMouseDown: event
	^ true! !

!TxTextEditorMorph methodsFor: 'initialization' stamp: 'FernandoOlivero 9/4/2013 14:24'!
initializeText: aTxModel 
	layoutViewMorph := self newViewMorphOn: aTxModel .
	cursorMorph := self defaultCursor.
	self updateController.
	! !

!TxTextEditorMorph methodsFor: 'editing' stamp: 'FernandoOlivero 9/4/2013 14:28'!
insertAtCursor: aCharacter 	
	controller insert: aCharacter.
	self controllerChanged.! !

!TxTextEditorMorph methodsFor: 'event handling' stamp: 'FernandoOlivero 9/4/2013 11:10'!
keyStroke: anEvent 
	| keyCharacter |
	self flag: 'used KeyMappings instead!!'.
	keyCharacter := anEvent keyCharacter .
	keyCharacter = Character backspace  ifTrue:[ ^ self deleteAtCursor ]. 
	
	self insertAtCursor:  keyCharacter. 
	
	! !

!TxTextEditorMorph methodsFor: 'event handling' stamp: 'FernandoOlivero 9/4/2013 11:11'!
mouseDown: anEvent
 	self moveCursorTo:  anEvent position - self topLeft .
	! !

!TxTextEditorMorph methodsFor: 'event handling' stamp: 'FernandoOlivero 9/4/2013 11:11'!
mouseMove: anEvent! !

!TxTextEditorMorph methodsFor: 'editing' stamp: 'FernandoOlivero 9/4/2013 11:47'!
moveCursorLeft 
	controller moveToLeft .
	self cursorChanged.! !

!TxTextEditorMorph methodsFor: 'editing' stamp: 'FernandoOlivero 9/4/2013 11:47'!
moveCursorRight
	controller moveToRight .
	self cursorChanged.! !

!TxTextEditorMorph methodsFor: 'editing' stamp: 'FernandoOlivero 9/4/2013 14:13'!
moveCursorTo: aPoint  
	| textPosition |
	self flag: 'should we use text index here?'.
	textPosition := layoutViewMorph textPositionAt: aPoint.
	controller moveTo: textPosition textIndex.
	self cursorChanged.
	! !

!TxTextEditorMorph methodsFor: 'initialization' stamp: 'FernandoOlivero 9/4/2013 14:18'!
newViewMorphOn: aTxModel 
	^ TxLayoutViewMorph text: aTxModel .
! !

!TxTextEditorMorph methodsFor: 'updating' stamp: 'FernandoOlivero 9/4/2013 14:18'!
ownerChanged
	self updateLayoutView. 
	self updateCursor .
	! !

!TxTextEditorMorph methodsFor: 'event handling' stamp: 'FernandoOlivero 9/4/2013 11:11'!
takesKeyboardFocus
	^ true! !

!TxTextEditorMorph methodsFor: 'accesing' stamp: 'FernandoOlivero 9/4/2013 12:56'!
text
	^ layoutViewMorph text ! !

!TxTextEditorMorph methodsFor: 'updating' stamp: 'FernandoOlivero 9/4/2013 12:36'!
updateController
	controller := TxTextEditorController text: self text.
	self controllerChanged.! !

!TxTextEditorMorph methodsFor: 'updating' stamp: 'FernandoOlivero 9/4/2013 14:17'!
updateCursor
	| position |
	position := layoutViewMorph layoutPositionAt:  self cursorTextPosition ifOutside: [ self error: 'cursorTextPosition should always be within the layout ?' ].
	cursorMorph updateTo: position
	  ! !

!TxTextEditorMorph methodsFor: 'updating' stamp: 'FernandoOlivero 9/4/2013 14:26'!
updateLayoutView
	layoutViewMorph extent: self innerBounds extent; extentChanged.! !

SEAbstractFocus subclass: #TxTextFocus
	instanceVariableNames: 'cursorPosition'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TxText-Athens'!

!TxTextFocus methodsFor: 'acccessing' stamp: 'FernandoOlivero 9/4/2013 12:51'!
cursorPosition
	^ cursorPosition! !

!TxTextFocus methodsFor: 'operations' stamp: 'FernandoOlivero 9/3/2013 10:58'!
deconstruct
	^ self model asString! !

!TxTextFocus methodsFor: 'operations' stamp: 'FernandoOlivero 9/4/2013 12:54'!
delete
	cursorPosition  removePreviousCharacter! !

!TxTextFocus methodsFor: 'initialization' stamp: 'FernandoOlivero 9/4/2013 14:11'!
initializeFromModel: aModel
	super initializeFromModel: aModel.
	cursorPosition := aModel startPosition.
	self addAfter: self deconstruct .! !

!TxTextFocus methodsFor: 'operations' stamp: 'FernandoOlivero 9/4/2013 14:04'!
insert: aTextModelElement
	cursorPosition insert: aTextModelElement.
	self addBefore: aTextModelElement .! !

!TxTextFocus methodsFor: 'operations' stamp: 'FernandoOlivero 9/4/2013 14:03'!
moveLeft 
	self moveLeft: 1! !

!TxTextFocus methodsFor: 'operations' stamp: 'FernandoOlivero 9/4/2013 14:09'!
moveLeft: anInteger 
	cursorPosition moveLeft: anInteger.
	
	self addAfter: ( self  removeBefore: anInteger )! !

!TxTextFocus methodsFor: 'operations' stamp: 'FernandoOlivero 9/4/2013 14:02'!
moveRight
	self moveRight: 1! !

!TxTextFocus methodsFor: 'operations' stamp: 'FernandoOlivero 9/4/2013 14:10'!
moveRight: anInteger 
	cursorPosition moveRight: anInteger.
	self addBefore: (self removeAfter: anInteger )! !

Object subclass: #TxAthensCursor
	instanceVariableNames: 'paint layoutPosition bounds'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TxText-Athens'!

!TxAthensCursor methodsFor: 'drawing' stamp: 'FernandoOlivero 9/3/2013 00:46'!
drawOn: aCanvas 
	self subclassResponsibility ! !

!TxAthensCursor methodsFor: 'geometry' stamp: 'FernandoOlivero 9/4/2013 13:52'!
extent
	| width height |
	width := 2.
	height := layoutPosition line maxAscent  .
	^ width @ height ! !

!TxAthensCursor methodsFor: 'initialize-release' stamp: 'FernandoOlivero 9/4/2013 13:55'!
initialize 
	super initialize.
	bounds := 0@0 extent: 1 @10. 
	paint := Color blue.! !

!TxAthensCursor methodsFor: 'geometry' stamp: 'FernandoOlivero 9/4/2013 13:52'!
position
	^ layoutPosition topPointInView ! !

!TxAthensCursor methodsFor: 'updating' stamp: 'FernandoOlivero 9/4/2013 13:53'!
updateTo: aLayoutPosition  
	layoutPosition  := aLayoutPosition .
	bounds := self position extent: self extent .! !

TxAthensCursor subclass: #TxBlockCursor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TxText-Athens'!

!TxBlockCursor commentStamp: '<historical>' prior: 0!
when it was not possible to show a vertical bar between characters to show where the new text would be inserted, so an underscore or block cursor was used instead!

TxAthensCursor subclass: #TxCaretCursor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TxText-Athens'!

!TxCaretCursor commentStamp: '<historical>' prior: 0!
In most command-line interfaces or text editors, the text cursor or caret navigation, is an underscore, a solid rectangle, or a vertical line, which may be flashing or steady, indicating where text will be placed when entered (the insertion point).!

!TxCaretCursor methodsFor: 'drawing' stamp: 'FernandoOlivero 9/3/2013 00:46'!
drawOn: aCanvas 
	aCanvas
		setPaint: paint ;
		setShape:  bounds  ;
		draw.! !

Object subclass: #TxAthensLayout
	instanceVariableNames: 'interval extent lines view'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TxText-Athens'!

!TxAthensLayout commentStamp: '<historical>' prior: 0!
i represent the cached visual layout of given text.

Note, that layout is considered an information maintained by concerete view, and not accessible (userful) without having a view.!

!TxAthensLayout methodsFor: 'scanning' stamp: 'IgorStasenko 8/8/2013 17:12'!
addLine: newLine

	lines add: newLine.
	extent := (extent x max: newLine width) @ extent y + newLine height! !

!TxAthensLayout methodsFor: 'accessing' stamp: 'IgorStasenko 8/8/2013 17:10'!
endPosition
	^ interval end! !

!TxAthensLayout methodsFor: 'geometry' stamp: 'IgorStasenko 8/8/2013 17:09'!
extent
	^ extent! !

!TxAthensLayout methodsFor: 'geometry' stamp: 'IgorStasenko 8/27/2013 11:47'!
fontMetricsProviderFor: aFont 
	^ view fontMetricsProviderFor: aFont ! !

!TxAthensLayout methodsFor: 'initialize-release' stamp: 'IgorStasenko 8/8/2013 03:18'!
initialize
	lines := OrderedCollection new.
	extent := 0@0.! !

!TxAthensLayout methodsFor: 'accessing' stamp: 'IgorStasenko 8/8/2013 17:09'!
interval
	^ interval! !

!TxAthensLayout methodsFor: 'accessing' stamp: 'IgorStasenko 8/6/2013 18:16'!
interval: anInterval
	interval := anInterval! !

!TxAthensLayout methodsFor: 'accessing' stamp: 'IgorStasenko 8/8/2013 18:08'!
lines
	^ lines! !

!TxAthensLayout methodsFor: 'accessing' stamp: 'FernandoOlivero 8/25/2013 11:10'!
numberOfLines
	^ lines size! !

!TxAthensLayout methodsFor: 'geometry' stamp: 'IgorStasenko 8/27/2013 15:37'!
positionAt: aTextPosition ifOutside: aBlock
	(interval contains: aTextPosition)
		ifTrue:[ ^ TxAthensLayoutPosition textPosition: aTextPosition layout: self ] 
		ifFalse: [  ^ aBlock value ].
		 
! !

!TxAthensLayout methodsFor: 'scanning' stamp: 'FernandoOlivero 9/3/2013 01:39'!
scanLineUsing: strategy

	| newLine end newLineEnd |
	interval end isAtEnd ifTrue: [  ^ self  ]. "nothing left to scan"
	end := interval end.
	
	newLine := TxAthensLayoutLine new.
	newLine layout: self.
	newLineEnd := strategy scanLine: newLine startingFrom: end.
	newLine endPosition: newLineEnd .
	interval end: newLineEnd.
	
	
	self addLine: newLine! !

!TxAthensLayout methodsFor: 'accessing' stamp: 'IgorStasenko 8/6/2013 18:25'!
startPosition
	^ interval start! !

!TxAthensLayout methodsFor: 'accessing' stamp: 'IgorStasenko 8/30/2013 13:24'!
text
	^ interval start text! !

!TxAthensLayout methodsFor: 'geometry' stamp: 'FernandoOlivero 9/2/2013 16:03'!
textPositionAt: aPoint
	|  line height index |
	self numberOfLines = 0 ifTrue:[ ^ 0 ].
	 
	"find the line under the aPoint y by: accumulating the heights starting from the first line of the layout,  till we reach the Y of the point"
	
	aPoint y <= 0 ifTrue: [ ^ lines first  textPositionAtHorizontalOffset: aPoint x ].
	
	height := 0.
	index := 1.
	[ index <= lines size and:[ height < aPoint y ]] whileTrue:[
		line := lines at: index.
		height := height + line height.
		index := index + 1
	].
	
	index > lines size ifTrue: [  ^ lines last  textPositionAtHorizontalOffset: aPoint x ].
	
	^ line textPositionAtHorizontalOffset: aPoint x ! !

!TxAthensLayout methodsFor: 'accessing' stamp: 'IgorStasenko 8/27/2013 15:37'!
view
	^ view! !

!TxAthensLayout methodsFor: 'accessing' stamp: 'IgorStasenko 8/27/2013 11:47'!
view: aLayoutView
	view := aLayoutView! !

Object subclass: #TxAthensLayoutLine
	instanceVariableNames: 'interval commands width height baselineOffset maxAscent layout'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TxText-Athens'!

!TxAthensLayoutLine methodsFor: 'accessing' stamp: 'IgorStasenko 8/12/2013 15:24'!
accumulateAscent: asc
	maxAscent := maxAscent max: asc! !

!TxAthensLayoutLine methodsFor: 'accessing' stamp: 'IgorStasenko 8/8/2013 17:56'!
accumulateHeight: h
	height := height max: h! !

!TxAthensLayoutLine methodsFor: 'accessing' stamp: 'IgorStasenko 8/12/2013 15:33'!
addCommand: cmd

	commands add: cmd
	! !

!TxAthensLayoutLine methodsFor: 'scanning' stamp: 'IgorStasenko 8/8/2013 17:07'!
addWidth: aNumber 
	width := width + aNumber! !

!TxAthensLayoutLine methodsFor: 'accessing' stamp: 'IgorStasenko 8/8/2013 16:36'!
baselineOffset
	^ baselineOffset! !

!TxAthensLayoutLine methodsFor: 'accessing' stamp: 'IgorStasenko 8/8/2013 03:19'!
commands
	
	^ commands! !

!TxAthensLayoutLine methodsFor: 'rendering' stamp: 'IgorStasenko 8/26/2013 13:07'!
debugRenderOn: aTxTextRenderer 
	
	aTxTextRenderer canvas 
		setPaint: Color red;
		drawShape: (0@ maxAscent negated corner: width@(maxAscent negated+height)).
	
	commands do: [:cmd | cmd renderOn: aTxTextRenderer ]! !

!TxAthensLayoutLine methodsFor: 'accessing' stamp: 'IgorStasenko 8/8/2013 16:39'!
endPosition
	^ interval end ! !

!TxAthensLayoutLine methodsFor: 'accessing' stamp: 'IgorStasenko 8/8/2013 16:35'!
endPosition: aTxTextPosition 
	interval 
		ifNil: [ interval := (aTxTextPosition to: aTxTextPosition) beSelection ]
		ifNotNil: [  interval end: aTxTextPosition ]! !

!TxAthensLayoutLine methodsFor: 'geometry' stamp: 'IgorStasenko 8/8/2013 16:36'!
height
	^ height! !

!TxAthensLayoutLine methodsFor: 'geometry' stamp: 'IgorStasenko 8/8/2013 16:36'!
height: anObject
	height := anObject! !

!TxAthensLayoutLine methodsFor: 'geometry' stamp: 'IgorStasenko 8/27/2013 15:01'!
horizontalOffsetFor: textPosition 
	
	| totalAdvance |
	
	totalAdvance := 0. 
	
	"special case, when line starting position don't matching the first command position"
	commands first startPosition > textPosition ifTrue: [  ^ 0 ]. 
		
	commands do: [:cmd |
		(cmd contains: textPosition) ifTrue: [
			^ totalAdvance + (cmd horizontalAdvanceUpTo: textPosition layout: layout)
			  ]
		ifFalse: [ totalAdvance := totalAdvance + cmd advance x]
	].

	"if we reach here, just answert he accumulated total advance"
	^ totalAdvance! !

!TxAthensLayoutLine methodsFor: 'initalize-release' stamp: 'IgorStasenko 8/12/2013 15:23'!
initialize
	super initialize.
	maxAscent := height := baselineOffset := width := 0.
	commands := OrderedCollection new! !

!TxAthensLayoutLine methodsFor: 'accessing' stamp: 'IgorStasenko 8/8/2013 03:19'!
interval
	
	^ interval! !

!TxAthensLayoutLine methodsFor: 'accessing' stamp: 'IgorStasenko 8/27/2013 14:58'!
layout
	^ layout! !

!TxAthensLayoutLine methodsFor: 'initalize-release' stamp: 'IgorStasenko 8/27/2013 14:58'!
layout: aLayout
	layout := aLayout ! !

!TxAthensLayoutLine methodsFor: 'accessing' stamp: 'IgorStasenko 8/12/2013 15:22'!
maxAscent
	^ maxAscent! !

!TxAthensLayoutLine methodsFor: 'rendering' stamp: 'IgorStasenko 8/26/2013 13:07'!
renderOn: aTxTextRenderer 
	
"	aTxTextRenderer canvas 
		setPaint: Color red;
		drawShape: (0@ maxAscent negated corner: width@(maxAscent negated+height)).
"	
	commands do: [:cmd | cmd renderOn: aTxTextRenderer ]! !

!TxAthensLayoutLine methodsFor: 'accessing' stamp: 'FernandoOlivero 8/26/2013 16:30'!
startPosition
	^ interval start! !

!TxAthensLayoutLine methodsFor: 'accessing' stamp: 'IgorStasenko 8/8/2013 16:34'!
startPosition: aTxTextPosition 
	interval 
		ifNil: [ interval := (aTxTextPosition to: aTxTextPosition) beSelection ]
		ifNotNil: [  interval start: aTxTextPosition ]! !

!TxAthensLayoutLine methodsFor: 'geometry' stamp: 'IgorStasenko 8/27/2013 15:11'!
textPositionAtHorizontalOffset: anOffset 
	| advance |
	anOffset < 0 ifTrue:[ ^ self startPosition ].
	advance := 0.
	commands do: [:cmd | 
		(cmd advance x + advance > anOffset)
			ifTrue:[ ^ cmd textPositionForHorizontalOffset: anOffset - advance layout: layout].
		advance := advance + cmd advance x ].
	^ self endPosition ! !

!TxAthensLayoutLine methodsFor: 'geometry' stamp: 'IgorStasenko 8/8/2013 16:36'!
width
	^ width! !

!TxAthensLayoutLine methodsFor: 'geometry' stamp: 'IgorStasenko 8/8/2013 16:36'!
width: anObject
	width := anObject! !

Object subclass: #TxAthensLayoutPosition
	instanceVariableNames: 'textPosition layout line lineTopOffset horizontalOffset'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TxText-Athens'!

!TxAthensLayoutPosition commentStamp: '<historical>' prior: 0!
i provide mapping from text position (TxTextPosition)
to position inside view's layout.

!

!TxAthensLayoutPosition class methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 8/27/2013 11:34'!
textPosition: textPosition layout: txLayout

	^ self new textPosition: textPosition layout: txLayout
! !

!TxAthensLayoutPosition methodsFor: 'accessing' stamp: 'IgorStasenko 8/27/2013 12:51'!
baselinePoint
	"answer the point at baseline matching with given layout position"
	
	^ horizontalOffset @ (lineTopOffset + line maxAscent )! !

!TxAthensLayoutPosition methodsFor: 'accessing' stamp: 'IgorStasenko 8/27/2013 12:52'!
baselinePointInView
	"answer the point at baseline matching with given layout position"
	
	^ self baselinePoint + layout view offset! !

!TxAthensLayoutPosition methodsFor: 'accessing' stamp: 'IgorStasenko 8/27/2013 15:42'!
horizontalOffset
	^ horizontalOffset! !

!TxAthensLayoutPosition methodsFor: 'accessing' stamp: 'FernandoOlivero 9/2/2013 15:37'!
line
	^ line ! !

!TxAthensLayoutPosition methodsFor: 'initializing' stamp: 'FernandoOlivero 9/2/2013 16:05'!
textPosition: aTextPosition layout: txLayout
	
	textPosition := aTextPosition.
	layout := txLayout.
	
	self updateInfo.
	
 ! !

!TxAthensLayoutPosition methodsFor: 'accessing' stamp: 'IgorStasenko 8/27/2013 12:51'!
topPoint
	"answer the point at baseline matching with given layout position"
	
	^ horizontalOffset @ lineTopOffset ! !

!TxAthensLayoutPosition methodsFor: 'accessing' stamp: 'IgorStasenko 8/27/2013 12:51'!
topPointInView
	"answer the point at baseline matching with given layout position"
	
	^ self topPoint + layout view offset! !

!TxAthensLayoutPosition methodsFor: 'calculating' stamp: 'FernandoOlivero 9/3/2013 01:19'!
updateInfo

 	lineTopOffset := 0.
	
	layout lines do: [:each |
		(each interval contains: textPosition) ifTrue: [ 
			"found the line"
			line := each.
			horizontalOffset := line horizontalOffsetFor: textPosition .
			^ self
		].
	
		lineTopOffset := lineTopOffset + each height.
	].

	horizontalOffset isNil ifTrue:[ self error: 'should not get here!!'].! !

Object subclass: #TxAthensLayoutStrategy
	instanceVariableNames: 'start view layout'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TxText-Athens'!

TxAthensLayoutStrategy subclass: #TxAthensCharacterWrappingStrategy
	instanceVariableNames: 'finished currentLine'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TxText-Athens'!

!TxAthensCharacterWrappingStrategy methodsFor: 'private' stamp: 'FernandoOlivero 9/3/2013 01:32'!
reset
	currentLine := nil.
	finished := false.! !

!TxAthensCharacterWrappingStrategy methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 8/30/2013 15:44'!
scanLine: line startingFrom: aLineStart
	"Scan the text line, until strategy conditions are met.
	No-wrap strategy ends scanning only when it meets the line end (or text end)"
	| span end |
	
	currentLine := line.
	line 
		startPosition: aLineStart; 
		endPosition: aLineStart copy.
	
	span := aLineStart span.
	finished := false.
	[ end := span accept: self. finished ] whileFalse: [ 
		span := span nextIfNone: [  ^ span endPosition ].
	].
	^ end! !

!TxAthensCharacterWrappingStrategy methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 8/30/2013 15:44'!
visitCharacterSpan: aSpan
	
	| chars pos startPos font w  fontMetricsProvider  viewWidth  glyphWidth  |
	
	chars := aSpan characters.
	
	startPos := pos := currentLine endPosition spanPosition.

	
	font := aSpan getAttribute: TxFontAttribute.  
	
	fontMetricsProvider := view fontMetricsProviderFor: font.
	currentLine accumulateHeight: fontMetricsProvider fontHeight.
	currentLine accumulateAscent: fontMetricsProvider fontAscent.
	
	viewWidth := view extent x.
	glyphWidth := w := 0.
	startPos := pos + 1.
	
	[ pos < chars size and: [  
		glyphWidth := (fontMetricsProvider getGlyphWidth: (chars at: pos+1)).
		finished := (currentLine width + glyphWidth > viewWidth). finished not  ] ] whileTrue: [  
	
		currentLine addWidth: glyphWidth.
		w := w + glyphWidth.
		pos := pos +1.
	].

	pos >= chars size 
		ifTrue: [  
			"scanned till the end of span"
			currentLine endPosition: aSpan endPosition.
			
			currentLine addCommand: (TxCharacterSpanDisplayCommand new span: aSpan;
				start: startPos ; stop: chars size; advance: w@0; yourself).
			
			^ aSpan next startPosition
			]
		ifFalse: [  
			"stopped in the middle of span"
			currentLine endPosition spanPosition: pos.
			currentLine addCommand: (TxCharacterSpanDisplayCommand new span: aSpan;
				start: startPos; stop: pos; advance: w@0; yourself).
				
			^ TxTextPosition onSpan: aSpan at: pos
		 ].
	! !

!TxAthensCharacterWrappingStrategy methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 8/30/2013 15:42'!
visitEndSpan: aSpan

	finished := true.
	currentLine endPosition: aSpan startPosition.
	^ aSpan endPosition! !

!TxAthensCharacterWrappingStrategy methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 8/30/2013 15:42'!
visitLineSeparator: aSpan

	finished := true.
	currentLine endPosition: aSpan prev endPosition.
	
	^ aSpan next startPosition ! !

!TxAthensCharacterWrappingStrategy methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 8/30/2013 15:42'!
visitStartSpan: aSpan

	"do nothing"
	^ aSpan next startPosition ! !

!TxAthensLayoutStrategy methodsFor: 'building' stamp: 'FernandoOlivero 9/3/2013 01:30'!
computeLayoutFor: aView position: aStartingPosition 

	self reset.

	start := aStartingPosition copy moveToLineStart.
	view := aView.
	
	layout := TxAthensLayout new 
		view: aView;
		interval:  (start to: start) beSelection.
	
	"scan lines of text until its enough for current view, or there's nothing left to scan"
	[ layout scanLineUsing: self. 
		(layout extent y <= view extent y) and: [ layout endPosition isAtEnd not ] ] whileTrue.
	
	^ layout! !

!TxAthensLayoutStrategy methodsFor: 'building' stamp: 'FernandoOlivero 9/3/2013 01:31'!
reset	
	"I'm about to compute a layout, reset  my state"
	^ self subclassResponsibility ! !

!TxAthensLayoutStrategy methodsFor: 'scanning' stamp: 'IgorStasenko 8/8/2013 03:13'!
scanLine: aTxLayoutLine
	"scan the text line, until strategy conditions are met"
	
	self subclassResponsibility! !

!TxAthensLayoutStrategy methodsFor: 'scanning' stamp: 'IgorStasenko 8/30/2013 15:40'!
scanLine: aTxLayoutLine startingFrom: aLineStart
	"Scan the text line, until strategy conditions are met.
	Answer the position where the next line starts"
	
	self subclassResponsibility! !

TxAthensLayoutStrategy subclass: #TxAthensNoWrapStrategy
	instanceVariableNames: 'finished currentLine'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TxText-Athens'!

!TxAthensNoWrapStrategy commentStamp: '<historical>' prior: 0!
I'm a layout strategy that computes the layout of each line from the starting position to the end of the line.

Therefore, I compute the line as it is,  and its up to the view to clip all the characters outside of the layout view's extent.

!

!TxAthensNoWrapStrategy methodsFor: 'private' stamp: 'FernandoOlivero 9/3/2013 01:32'!
reset
	currentLine := nil.
	finished := false.! !

!TxAthensNoWrapStrategy methodsFor: 'scanning' stamp: 'IgorStasenko 8/30/2013 15:42'!
scanLine: line startingFrom: aLineStart
	"Scan the text line, until strategy conditions are met.
	No-wrap strategy ends scanning only when it meets the line end (or text end)"
	| span end |
	
	currentLine := line.
	line 
		startPosition: aLineStart; 
		endPosition: aLineStart copy.
	
	span := aLineStart span.
	finished := false.
	[ end := span accept: self. finished ] whileFalse: [ 
		span := span nextIfNone: [  ^ span endPosition ].
	].
	^ end! !

!TxAthensNoWrapStrategy methodsFor: 'visiting' stamp: 'IgorStasenko 8/30/2013 15:31'!
visitCharacterSpan: aSpan
	
	| chars startPos font w  fontMetricsProvider |
	
	chars := aSpan characters.
	
	startPos := currentLine endPosition spanPosition.
	startPos = 0 ifTrue: [  startPos := 1 ].
	
	
	font := aSpan getAttribute: TxFontAttribute.  
	
	fontMetricsProvider := view fontMetricsProviderFor: font.
	currentLine accumulateHeight: fontMetricsProvider fontHeight.
	currentLine accumulateAscent: fontMetricsProvider fontAscent.
	
	w := 0.
	startPos to: chars size do: [ :i |
			w := w + (fontMetricsProvider getGlyphWidth: (chars at:i))
	].
	currentLine addWidth: w.

	currentLine addCommand: (TxCharacterSpanDisplayCommand new span: aSpan;
		start: startPos; stop: aSpan size; advance: w@0; yourself).
		
	^ aSpan next startPosition! !

!TxAthensNoWrapStrategy methodsFor: 'visiting' stamp: 'IgorStasenko 8/30/2013 15:31'!
visitEndSpan: aSpan

	finished := true.
	currentLine endPosition: aSpan startPosition.
	^ aSpan startPosition! !

!TxAthensNoWrapStrategy methodsFor: 'visiting' stamp: 'IgorStasenko 8/30/2013 15:30'!
visitLineSeparator: aSpan

	finished := true.
	currentLine endPosition: aSpan prev endPosition.
	
	^ aSpan next startPosition.! !

!TxAthensNoWrapStrategy methodsFor: 'visiting' stamp: 'IgorStasenko 8/30/2013 15:31'!
visitStartSpan: aSpan

	"do nothing"
	^ aSpan next startPosition! !

Object subclass: #TxAthensLayoutView
	instanceVariableNames: 'extent layoutStrategy layout offset'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TxText-Athens'!

!TxAthensLayoutView class methodsFor: 'instance creation' stamp: 'IgorStasenko 8/30/2013 13:26'!
on: aTxModel extent: aPoint
	^ self new
		initWithPosition: aTxModel startPosition extent: aPoint
! !

!TxAthensLayoutView methodsFor: 'debug rendering' stamp: 'IgorStasenko 8/26/2013 13:06'!
debugRenderOn: canvas

	"
	set up clipping
	- draw line by line
	"
	| renderer |

	canvas
		setStrokePaint: Color green;
		drawShape: (0@0 corner: self extent).

	renderer := TxTextRenderer new.
	renderer renderLines: layout lines on: canvas.
	
! !

!TxAthensLayoutView methodsFor: 'defaults' stamp: 'FernandoOlivero 8/26/2013 11:13'!
defaultStrategy
	^ TxAthensCharacterWrappingStrategy new! !

!TxAthensLayoutView methodsFor: 'accessing' stamp: 'IgorStasenko 8/5/2013 17:25'!
extent
	^ extent! !

!TxAthensLayoutView methodsFor: 'accessing' stamp: 'IgorStasenko 8/26/2013 12:48'!
extent: aPoint 
	extent := aPoint.
	self resetLayout.! !

!TxAthensLayoutView methodsFor: 'geometry' stamp: 'IgorStasenko 8/30/2013 16:14'!
fontMetricsProviderFor: aFont 

"aFont glyphRendererOn: surface."

	^ CairoFontMetricsProvider new 
			font: aFont ;
			yourself ! !

!TxAthensLayoutView methodsFor: 'initializing' stamp: 'FernandoOlivero 8/26/2013 16:11'!
initWithPosition: aStartPosition extent: aPoint
	
	
	^ self initWithStrategy: self defaultStrategy position: aStartPosition extent: aPoint! !

!TxAthensLayoutView methodsFor: 'initializing' stamp: 'IgorStasenko 8/27/2013 11:49'!
initWithStrategy: aLayoutStrategy position: aStartPosition extent: aPoint
	
	offset := 0@0.
	layoutStrategy := aLayoutStrategy.
	extent := aPoint.
	
	layout := layoutStrategy computeLayoutFor: self position: aStartPosition.
	! !

!TxAthensLayoutView methodsFor: 'initializing' stamp: 'IgorStasenko 8/22/2013 13:36'!
initialize

	offset := 0@0.
	! !

!TxAthensLayoutView methodsFor: 'accessing' stamp: 'IgorStasenko 8/6/2013 18:12'!
layout
	^ layout! !

!TxAthensLayoutView methodsFor: 'geometry' stamp: 'IgorStasenko 8/27/2013 13:25'!
layoutPositionAt: aTextPosition ifOutside: aBlock
	"calculate the point at given text position, might return an invalid position (outside the layout)"
	^ self layout positionAt: aTextPosition ifOutside: aBlock! !

!TxAthensLayoutView methodsFor: 'accessing' stamp: 'IgorStasenko 8/6/2013 17:41'!
layoutStrategy
	^ layoutStrategy! !

!TxAthensLayoutView methodsFor: 'accessing' stamp: 'IgorStasenko 8/26/2013 11:30'!
layoutStrategy: anObject
	layoutStrategy := anObject.
	self resetLayout.! !

!TxAthensLayoutView methodsFor: 'accessing' stamp: 'IgorStasenko 8/6/2013 14:46'!
offset
	^ offset! !

!TxAthensLayoutView methodsFor: 'rendering' stamp: 'IgorStasenko 8/26/2013 13:06'!
renderOn: canvas

	"
	set up clipping
	- draw line by line
	"
	| renderer |

	renderer := TxTextRenderer new.
	renderer renderLines: layout lines on: canvas.
	
! !

!TxAthensLayoutView methodsFor: 'initializing' stamp: 'IgorStasenko 8/12/2013 15:26'!
resetLayout
	
	layout := layoutStrategy computeLayoutFor: self position: layout startPosition! !

!TxAthensLayoutView methodsFor: 'accessing' stamp: 'IgorStasenko 8/30/2013 13:23'!
text
	^ layout text! !

!TxAthensLayoutView methodsFor: 'geometry' stamp: 'IgorStasenko 8/27/2013 13:33'!
textPositionAt: aPoint
	"Answer the text position closest to given point in view"
	^ self layout textPositionAt: aPoint - offset ! !

Object subclass: #TxDisplayCommand
	instanceVariableNames: 'next'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TxText-Athens'!

TxDisplayCommand subclass: #TxCharacterSpanDisplayCommand
	instanceVariableNames: 'span start stop advance'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TxText-Athens'!

!TxCharacterSpanDisplayCommand methodsFor: 'accessing' stamp: 'IgorStasenko 8/22/2013 15:08'!
advance
	
	^ advance! !

!TxCharacterSpanDisplayCommand methodsFor: 'accessing' stamp: 'IgorStasenko 8/22/2013 15:08'!
advance: anObject
	
	advance := anObject! !

!TxCharacterSpanDisplayCommand methodsFor: 'testing' stamp: 'IgorStasenko 8/27/2013 12:14'!
contains: aTextPosition

	"this one is tricky and should be covered by tests, because
	start and stop here is start charater index and stop character index, but not positions
	 "
	
	self flag: #coverByTest.
	
	^ aTextPosition span == span and: [ | spanPos |  
			spanPos := aTextPosition spanPosition.
			spanPos between: start-1 and: stop ]! !

!TxCharacterSpanDisplayCommand methodsFor: 'geometry' stamp: 'IgorStasenko 8/27/2013 15:19'!
fontMetricsProvider: aTextLayout
	| font |
	font := self span getAttribute: TxFontAttribute.  
	^ aTextLayout  fontMetricsProviderFor: font.
! !

!TxCharacterSpanDisplayCommand methodsFor: 'geometry' stamp: 'IgorStasenko 8/30/2013 13:43'!
horizontalAdvanceUpTo: aTextPosition layout: aTextLayout
	<compilerOptions: #(- optionInlineToDo )>
	| horizontalAdvance fontMetricsProvider   characters spanPosition |

	fontMetricsProvider := self  fontMetricsProvider: aTextLayout. 
	horizontalAdvance := 0.
	characters := self span characters.
	spanPosition := aTextPosition spanPosition.
	
	start to: stop do: [ :index |
		| glyphWidth |
		index > spanPosition  ifTrue: [  ^ horizontalAdvance ].
		glyphWidth := fontMetricsProvider getGlyphWidth: (characters at: index).
		horizontalAdvance := horizontalAdvance + glyphWidth.
	].
	"we should never reach here"
	^ horizontalAdvance! !

!TxCharacterSpanDisplayCommand methodsFor: 'rendering' stamp: 'IgorStasenko 8/22/2013 15:10'!
renderOn: renderer

	renderer setFont: (span getAttribute: TxFontAttribute).
	renderer setColor: (span getAttribute: TxForeColorAttribute).
	
	renderer renderCharacters: span characters from: start to: stop.
	renderer advance:advance.! !

!TxCharacterSpanDisplayCommand methodsFor: 'accessing' stamp: 'IgorStasenko 8/12/2013 15:31'!
span
	^ span! !

!TxCharacterSpanDisplayCommand methodsFor: 'accessing' stamp: 'IgorStasenko 8/12/2013 15:31'!
span: anObject
	span := anObject! !

!TxCharacterSpanDisplayCommand methodsFor: 'accessing' stamp: 'IgorStasenko 8/12/2013 15:31'!
start
	^ start! !

!TxCharacterSpanDisplayCommand methodsFor: 'accessing' stamp: 'IgorStasenko 8/12/2013 15:31'!
start: anObject
	start := anObject! !

!TxCharacterSpanDisplayCommand methodsFor: 'accessing' stamp: 'IgorStasenko 8/27/2013 12:41'!
startPosition
	"answer the text position, matching the start of command"
	^ TxTextPosition onSpan: span at: start -1! !

!TxCharacterSpanDisplayCommand methodsFor: 'accessing' stamp: 'IgorStasenko 8/12/2013 15:31'!
stop
	^ stop! !

!TxCharacterSpanDisplayCommand methodsFor: 'accessing' stamp: 'IgorStasenko 8/12/2013 15:31'!
stop: anObject
	stop := anObject! !

!TxCharacterSpanDisplayCommand methodsFor: 'geometry' stamp: 'IgorStasenko 8/30/2013 15:03'!
textPositionForHorizontalOffset: anOffset layout: layout
	| width fontMetricsProvider  |
	fontMetricsProvider := self fontMetricsProvider: layout.
	width := 0.
	start to: stop do: [ :index |
		| glyphWidth |	
		glyphWidth := fontMetricsProvider getGlyphWidth: (span characters at: index).
		width + glyphWidth  >=  anOffset ifTrue: [ 
			"if offset closer to left side of glyph, we answer the position prior to it,
			otherwise after it"
			anOffset - width < (glyphWidth/2) 
				ifTrue: [ ^ TxTextPosition onSpan: span at: index - 1 ]
				ifFalse: [ ^ TxTextPosition onSpan: span at: index ]
			].
		width := width + glyphWidth].
	^ TxTextPosition onSpan: span at: stop! !

!TxDisplayCommand methodsFor: 'accessing' stamp: 'IgorStasenko 8/8/2013 18:40'!
addLast: aCommand
	self tail next: aCommand! !

!TxDisplayCommand methodsFor: 'testing' stamp: 'IgorStasenko 8/27/2013 12:14'!
contains: aTextPosition
	self subclassResponsibility! !

!TxDisplayCommand methodsFor: 'accessing' stamp: 'IgorStasenko 8/8/2013 18:40'!
do: aBlock
	| nn |
	nn := self.
	
	[ nn isNil ] whileFalse: [ 
		aBlock value: nn.
		nn := nn next. ]! !

!TxDisplayCommand methodsFor: 'geometry' stamp: 'IgorStasenko 8/27/2013 12:15'!
horizontalAdvanceUpTo: textPosition layout: layout

	self subclassResponsibility! !

!TxDisplayCommand methodsFor: 'accessing' stamp: 'IgorStasenko 8/8/2013 18:40'!
insert: aCommands

	| nn |
	nn := next.
	next := aCommands.
	next tail next: nn! !

!TxDisplayCommand methodsFor: 'accessing' stamp: 'IgorStasenko 8/8/2013 18:40'!
next

	^ next! !

!TxDisplayCommand methodsFor: 'accessing' stamp: 'IgorStasenko 8/8/2013 18:40'!
next: anObject
	
	next := anObject! !

!TxDisplayCommand methodsFor: 'copying' stamp: 'IgorStasenko 8/8/2013 18:40'!
postCopy
	"unlink the copy by default"
	next := nil! !

!TxDisplayCommand methodsFor: 'rendering' stamp: 'IgorStasenko 8/8/2013 18:40'!
renderOn: renderer
	self shouldBeImplemented ! !

!TxDisplayCommand methodsFor: 'accessing' stamp: 'IgorStasenko 8/27/2013 12:40'!
startPosition
	"answer the text position, matching the start of command"
	self subclassResponsibility! !

!TxDisplayCommand methodsFor: 'accessing' stamp: 'IgorStasenko 8/8/2013 18:40'!
tail
	| nn |
	nn := self.
	[ nn next notNil ] whileTrue: [ nn := nn next ].
	^ nn! !

!TxDisplayCommand methodsFor: 'geometry' stamp: 'IgorStasenko 8/27/2013 15:11'!
textPositionForHorizontalOffset: anOffset layout: layout

	self subclassResponsibility! !

Object subclass: #TxTextEditorController
	instanceVariableNames: 'editor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TxText-Athens'!

!TxTextEditorController class methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 9/4/2013 12:37'!
text: aTxModel 
	| controller |
	controller := self new.
	controller initializeText: aTxModel .
	^ controller ! !

!TxTextEditorController methodsFor: 'accessing' stamp: 'FernandoOlivero 9/4/2013 12:50'!
cursorTextPosition
	^ editor focus cursorPosition ! !

!TxTextEditorController methodsFor: 'intialization' stamp: 'FernandoOlivero 9/4/2013 11:36'!
initializeText: aTxModel 
	editor := SEEditor new.
	editor editInstancesOf: aTxModel class with: TxTextFocus. 
	editor model: aTxModel.
	! !

!TxTextEditorController methodsFor: 'editing' stamp: 'FernandoOlivero 9/4/2013 14:29'!
insert: aCharacter 
	editor do: (self insertCommand: aCharacter )! !

!TxTextEditorController methodsFor: 'editing' stamp: 'FernandoOlivero 9/4/2013 14:29'!
insertCommand: aCharacter
	^ SEInsert item: aCharacter! !

!TxTextEditorController methodsFor: 'editing' stamp: 'FernandoOlivero 9/4/2013 11:41'!
moveTo: anIndex 
	editor do: (self moveToCommand: anIndex)
		! !

!TxTextEditorController methodsFor: 'commands' stamp: 'FernandoOlivero 9/4/2013 13:39'!
moveToCommand: anIndex
	| command |
	command := SEGroupCommand new.
	command
		addCommand: self moveToStartCommand	;
		addCommand: ( self moveToRightCommand: anIndex) .
	^ command	! !

!TxTextEditorController methodsFor: 'editing' stamp: 'FernandoOlivero 9/4/2013 11:47'!
moveToLeft
	editor do: self moveToLeftCommand.! !

!TxTextEditorController methodsFor: 'commands' stamp: 'FernandoOlivero 9/4/2013 11:49'!
moveToLeftCommand 
	^ self moveToLeftCommand: 1! !

!TxTextEditorController methodsFor: 'commands' stamp: 'FernandoOlivero 9/4/2013 11:44'!
moveToLeftCommand: anInteger  
	^ SEMove relativePosition: (SELeft repetition: anInteger )  ! !

!TxTextEditorController methodsFor: 'editing' stamp: 'FernandoOlivero 9/4/2013 11:47'!
moveToRight
	editor do: self moveToRightCommand.! !

!TxTextEditorController methodsFor: 'commands' stamp: 'FernandoOlivero 9/4/2013 11:46'!
moveToRightCommand 
	^ self moveToRightCommand: 1! !

!TxTextEditorController methodsFor: 'commands' stamp: 'FernandoOlivero 9/4/2013 11:43'!
moveToRightCommand: anInteger  
	^ SEMove relativePosition: (SERight repetition: anInteger )  ! !

!TxTextEditorController methodsFor: 'editing' stamp: 'FernandoOlivero 9/4/2013 13:39'!
moveToStart 
	editor do: self moveToStartCommand.! !

!TxTextEditorController methodsFor: 'commands' stamp: 'FernandoOlivero 9/4/2013 13:38'!
moveToStartCommand
	^ SEMove relativePosition: SEStart new ! !

Object subclass: #TxTextRenderer
	instanceVariableNames: 'text font canvas glyphRenderer color advance maxAscent currentLine'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TxText-Athens'!

!TxTextRenderer class methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 8/9/2013 15:31'!
textGoryDetails

"
Took from: http://www.freetype.org/freetype2/docs/tutorial/step2.html

(Font face metrics)
In this case, you can access the global design metrics as:

units_per_EM 	

This is the size of the EM square for the font face. It is used by scalable formats to scale design coordinates to device pixels, as described in the last chapter of this section. Its value usually is 2048 (for TrueType) or 1000 (for Type 1), but others are possible too. It is set to 1 for fixed-size formats like FNT/FON/PCF/BDF.

bbox 	

The global bounding box is defined as the largest rectangle that can enclose all the glyphs in a font face.

ascender 	

The ascender is the vertical distance from the horizontal baseline to the highest ‘character’ coordinate in a font face. Unfortunately, font formats define the ascender differently. For some, it represents the ascent of all capital latin characters (without accents), for others it is the ascent of the highest accented character, and finally, other formats define it as being equal to bbox.yMax.

descender 	

The descender is the vertical distance from the horizontal baseline to the lowest ‘character’ coordinate in a font face. Unfortunately, font formats define the descender differently. For some, it represents the descent of all capital latin characters (without accents), for others it is the ascent of the lowest accented character, and finally, other formats define it as being equal to bbox.yMin. This field is negative for values below the baseline.

height 	

This field is simply used to compute a default line spacing (i.e., the baseline-to-baseline distance) when writing text with this font. Note that it usually is larger than the sum of the ascender and descender taken as absolute values. There is also no guarantee that no glyphs extend above or below subsequent baselines when using this distance.

max_advance_width 	

This field gives the maximum horizontal cursor advance for all glyphs in the font. It can be used to quickly compute the maximum advance width of a string of text. It doesn't correspond to the maximum glyph image width!!

max_advance_height 	

Same as max_advance_width but for vertical text layout.

underline_position 	

When displaying or rendering underlined text, this value corresponds to the vertical position, relative to the baseline, of the underline bar's center. It is negative if it is below the baseline.

underline_thickness 	

When displaying or rendering underlined text, this value corresponds to the vertical thickness of the underline.


"! !

!TxTextRenderer methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 8/22/2013 15:21'!
advance: ad
	
	canvas pathTransform translateBy: ad! !

!TxTextRenderer methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 8/19/2013 16:01'!
canvas
	^ canvas! !

!TxTextRenderer methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 8/9/2013 15:31'!
initialize
	color := Color black.! !

!TxTextRenderer methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 8/22/2013 15:16'!
render: aText lines: lines on: aCanvas

	text := aText.
	canvas := aCanvas.
	
	canvas pathTransform restoreAfter: [

		lines do: [:line | |  |
			currentLine := line.
			maxAscent := line maxAscent.
			"set the origin to font's baseline position"
			canvas pathTransform translateX: 220 Y: maxAscent.
			"reset advance"
			advance := 0@0.
			canvas pathTransform restoreAfter: [
				line renderOn: self ].
			"line is rendered, advance vertically by line height"
			canvas pathTransform translateX: 0 Y: line height * 1.2 - maxAscent.
		] ]! !

!TxTextRenderer methodsFor: 'rendering' stamp: 'IgorStasenko 8/22/2013 15:18'!
renderCharacters: aString from: start to: stop 
	

	" accumulate advance while rendering spans"
	"canvas drawShape: (advance x @ advance y extent: 2 @ 2)."
	canvas 
		setPaint: color;
		setFont: font;
		drawString: aString from: start to: stop! !

!TxTextRenderer methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 8/22/2013 15:21'!
renderLines: lines on: aCanvas

	canvas := aCanvas.
	
	canvas pathTransform restoreAfter: [
		"canvas pathTransform rotateByDegrees: 15."
		lines do: [:line | |  |
			currentLine := line.
			maxAscent := line maxAscent.
			"set the origin to font's baseline position"
			canvas pathTransform translateX: 0 Y: maxAscent.
			"reset advance"
			advance := 0@0.
			
			canvas pathTransform restoreAfter: [
				line renderOn: self ].
			
			
			"line is rendered, advance vertically by line height"
			canvas pathTransform translateX: 0 Y: line height - maxAscent.

"			canvas pathTransform translateX: 0 Y: line height * 1.2 - maxAscent."
		] ]! !

!TxTextRenderer methodsFor: 'rendering' stamp: 'IgorStasenko 8/12/2013 16:03'!
setColor: aColor 
	color := aColor.! !

!TxTextRenderer methodsFor: 'rendering' stamp: 'IgorStasenko 8/12/2013 15:39'!
setFont: aFont 
	font := aFont! !
